unsigned char i;
unsigned char j;
unsigned char row;
unsigned char r[8] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};

int Max7219_pinCLK = 10;
int Max7219_pinCS = 11;
int Max7219_pinDIN = 8;


const int button1Pin = 3;  // КНОПКА ЛЕВО
const int button2Pin = 4;  // КНОПКА ПРАВО
const int button3Pin = 5;  // КНОПКА ВВЕРХ
const int button4Pin = 2;  // КНОПКА ВНИЗ
const int ledPin =  13;    // ПИН тестового светодиода


 
 
unsigned char disp1[33][8] = {
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // рисунок сердца
  0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x40, 0x40, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x80, 0x40, 0x40, 0x00, 0x00, 0x00,
  0x00, 0x80, 0x80, 0x40, 0x40, 0x00, 0x00, 0x00,
  0x40, 0x80, 0x80, 0x40, 0x40, 0x00, 0x00, 0x00,
  0x60, 0x80, 0x80, 0x40, 0x40, 0x00, 0x00, 0x00,
  0x60, 0x90, 0x80, 0x40, 0x40, 0x00, 0x00, 0x00,
  0x60, 0x90, 0x88, 0x40, 0x40, 0x00, 0x00, 0x00,
  0x60, 0x90, 0x88, 0x44, 0x40, 0x00, 0x00, 0x00,
  0x60, 0x90, 0x88, 0x44, 0x44, 0x00, 0x00, 0x00,
  0x60, 0x90, 0x88, 0x44, 0x44, 0x08, 0x00, 0x00,
  0x60, 0x90, 0x88, 0x44, 0x44, 0x08, 0x10, 0x00,
  0x60, 0x90, 0x88, 0x44, 0x44, 0x08, 0x10, 0x20,
  0x60, 0x90, 0x88, 0x44, 0x44, 0x08, 0x10, 0x60,
  0x60, 0x90, 0x88, 0x44, 0x44, 0x08, 0x90, 0x60,
  0x60, 0x90, 0x88, 0x44, 0x44, 0x88, 0x90, 0x60 // рисунок сердца
};

void Write_Max7219_byte(unsigned char DATA) {
  unsigned char i;
  digitalWrite(Max7219_pinCS, LOW);
  for (i = 8; i >= 1; i--) {
    digitalWrite(Max7219_pinCLK, LOW);
    digitalWrite(Max7219_pinDIN, DATA & 0x80);
    DATA = DATA << 1;
    digitalWrite(Max7219_pinCLK, HIGH);
  }
}

void Write_Max7219(unsigned char address, unsigned char dat) {
  digitalWrite(Max7219_pinCS, LOW);
  Write_Max7219_byte(address);
  Write_Max7219_byte(dat);
  digitalWrite(Max7219_pinCS, HIGH);
}

void Init_MAX7219(void) {
  Write_Max7219(0x09, 0x00);
  Write_Max7219(0x0a, 0x03);
  Write_Max7219(0x0b, 0x07);
  Write_Max7219(0x0c, 0x01);
  Write_Max7219(0x0f, 0x00);
}

void setup() {
  
  pinMode(button1Pin, INPUT);   // Инициализируем PIN на чтение данных
  pinMode(button2Pin, INPUT);
  pinMode(button3Pin, INPUT);
  pinMode(button4Pin, INPUT);
  pinMode(ledPin, OUTPUT); // Инициализация ПИНа светодиода


  
  pinMode(Max7219_pinCLK, OUTPUT);
  pinMode(Max7219_pinCS, OUTPUT);
  pinMode(Max7219_pinDIN, OUTPUT);
  delay(50);
  Init_MAX7219();
}


  
void loop() {

  int row= 1 + rand() %7; // Генерируем случайный ряд для змейки от 1 до 8.
  
  int button1State, button2State, button3State, button4State;  // Считываем нажатия кнопок  

 
  //рисуем змейку
// ряд если сножки-контакты внизу
// 1 - 0x80   
// 2 - 0x40   
// 3 - 0x20   
// 4 - 0x10   
// 5 - 0x08   
// 6 - 0x04   
// 7 - 0x02   
// 8 - 0x01   

 
  for (i = 1; i < 9; i++) {

  button1State = digitalRead(button1Pin);
  button2State = digitalRead(button2Pin);
  button3State = digitalRead(button3Pin);
  button4State = digitalRead(button4Pin);

    
  // Нажата кнопка ВВЕРХ
  if (button1State == LOW) { row++; digitalWrite(ledPin, HIGH);}  // ВКЛ. светодиод 
    if (button2State == LOW) { row--; digitalWrite(ledPin, HIGH);}  // ВКЛ. светодиод 
  else { digitalWrite(ledPin, LOW); } // ВЫКЛ. светодиод
if (row<1) {row=8;} // Если на краю поля, то переходим на первую строку
if (row>8) {row=1;} // Если на краю поля, то переходим на первую строку
    
    Write_Max7219(i, r[row]); 
    Write_Max7219(i-1, 0x00);

//if (i==7) { Write_Max7219(i, 0x00);}
if (i==8) { Write_Max7219(8, 0x00); Write_Max7219(i-1, 0x00);}
    
    delay(400);
  }
  

/* // сердце   
  for (j = 0; j < 17; j++) {
    for (i = 1; i < 9; i++)
      Write_Max7219(i, disp1[j][i - 1]);
    delay(100);
  }  
  */
  //все закрашиваем
/*  for (i = 1; i < 9; i++) {
    Write_Max7219(i, 0xFF);
    delay(100);
  }
*/  
  //все стираем
  //for (i = 1; i < 9; i++) {    Write_Max7219(i, 0x00);  }
  //пауза
//  delay(800);
}
